/*#include <i8042/i8042.h>
#include <klavier/_klavier.h>
#include <kos/asm.h>
#include <lib/stdio.h>
#include <idt/dsr.h>
*/
/*  don't forget to rewrite everything
 */
#define DATA_PORT    0x60
#define KB_WAIT() asm ( " pushl %eax     \n\t
			 0:             \n\t
			 inb $0x64,%al  \n\t
			 testb $2, %al  \n\t
			 jne 0b	       \n\t
			 popl %eax " );

//static tty_in_handler_t tty_in_handler = NULL; 

#define KBD_NOMODIFIER   0
#define KBD_SHIFT        1
#define KBD_LEFTSHIFT    2
#define KBD_RIGHTSHIFT   4
#define KBD_CTRL         8
#define KBD_LEFTCTRL    16
#define KBD_RIGHTCTRL   32
#define KBD_ALT         64
#define KBD_ALTGR      128

#define CAPS   4
#define NUM    2
#define SCROLL 1

extern char * video;
int ControlKeys;
unsigned int leds;

static int stoa(int sc) {
  int ch = 0;

  if(ControlKeys & KBD_SHIFT)
    {
      switch (sc) 
	{ 
	case 16: ch='Q'; break;
	case 17: ch='W'; break;
	case 18: ch='E'; break;
	case 19: ch='R'; break;
	case 20: ch='T'; break;
	case 21: ch='Y'; break;
	case 22: ch='U'; break;
	case 23: ch='I'; break;
	case 24: ch='O'; break;
	case 25: ch='P'; break;
	case 30: ch='A'; break;
	case 31: ch='S'; break;
	case 32: ch='D'; break;
	case 33: ch='F'; break;
	case 34: ch='G'; break;
	case 35: ch='H'; break;
	case 36: ch='J'; break;
	case 37: ch='K'; break;
	case 38: ch='L'; break;	
	case 44: ch='Z'; break;
	case 45: ch='X'; break;
	case 46: ch='C'; break;
	case 47: ch='V'; break;
	case 48: ch='B'; break;
	case 49: ch='N'; break;
	case 50: ch='M'; break;

	case 2: ch='!'; break;
	case 3: ch='@'; break;
	case 4: ch='#'; break; 
	case 5: ch='$'; break;
	case 6: ch='%'; break;
	case 7: ch='^'; break;
	case 8: ch='&'; break;
	case 9: ch='*'; break;
	case 10: ch='('; break;
	case 11: ch=')'; break;
	case 57: ch=' '; break;
//	case 14: ch=BS; break;
//	case 28: ch=EN; break;

	case 185: ch=' '; break;
//	case 142: ch=BS; break;
//	case 156: ch=EN; break;
				
//	case 59: ch=F1;	break;	
//	case 60: ch=F2;	break; 		
//	case 61: ch=F3;	break;
//	case 62: ch=F4;	break;		
//	case 63: ch=F5;	break;		
//	case 64: ch=F6;	break;		
//	case 65: ch=F7;	break;		
//	case 66: ch=F8;	break;		
//	case 67: ch=F9;	break;		
//	case 68: ch=F10; break;		

		
	case 13: ch='+'; break;
	case 26: ch='{'; break;
	case 27: ch='}'; break;
//	case 15: ch=TAB; break;
	case 122: ch='/'; break;
	case 43: ch='|'; break;
	case 53: ch='?'; break;
	
	default: ch=0; break;
	}
    }
  else if(ControlKeys & KBD_ALT)
    {
      switch(sc)
	{
//	case 59: ch=ALTF1;	break;	
//	case 60: ch=ALTF2;	break; 		
//	case 61: ch=ALTF3;	break;
//	case 62: ch=ALTF4;	break;		
//	case 63: ch=ALTF5;	break;		
//	case 64: ch=ALTF6;	break;		
//	case 65: ch=ALTF7;	break;		
//	case 66: ch=ALTF8;	break;		
	}
    }

  else
    {
      switch (sc) 
	{ 
	case 16: ch='q'; break;
	case 17: ch='w'; break;
	case 18: ch='e'; break;
	case 19: ch='r'; break;
	case 20: ch='t'; break;
	case 21: ch='y'; break;
	case 22: ch='u'; break;
	case 23: ch='i'; break;
	case 24: ch='o'; break;
	case 25: ch='p'; break;
	case 30: ch='a'; break;
	case 31: ch='s'; break;
	case 32: ch='d'; break;
	case 33: ch='f'; break;
	case 34: ch='g'; break;
	case 35: ch='h'; break;
	case 36: ch='j'; break;
	case 37: ch='k'; break;
	case 38: ch='l'; break;	
	case 44: ch='z'; break;
	case 45: ch='x'; break;
	case 46: ch='c'; break;
	case 47: ch='v'; break;
	case 48: ch='b'; break;
	case 49: ch='n'; break;
	case 50: ch='m'; break;

	case 2: ch='1'; break;
	case 3: ch='2'; break;
	case 4: ch='3'; break; 
	case 5: ch='4'; break;
	case 6: ch='5'; break;
	case 7: ch='6'; break;
	case 8: ch='7'; break;
	case 9: ch='8'; break;
	case 10: ch='9'; break;
	case 11: ch='0'; break;
	case 57: ch=' '; break;
//	case 14: ch=BS; break;
//	case 28: ch=EN; break;

	case 185: ch=' '; break;
//	case 142: ch=BS; break;
//	case 156: ch=EN; break;
				
//	case 59: ch=F1;	break;	
//	case 60: ch=F2;	break; 		
//	case 61: ch=F3;	break;
//	case 62: ch=F4;	break;		
//	case 63: ch=F5;	break;		
//	case 64: ch=F6;	break;		
//	case 65: ch=F7;	break;		
//	case 66: ch=F8;	break;		
//	case 67: ch=F9;	break;		
//	case 68: ch=F10; break;		

		
	case 13: ch='='; break;
	case 26: ch='['; break;
	case 27: ch=']'; break;
//	case 15: ch=TAB; break;
	case 122: ch='/'; break;
	case 43: ch='\\'; break;
	case 53: ch='/'; break;
	
	default: break;
	}
    }
  
  return ch;
}

static void set_leds(void)
{
	KB_WAIT();
        out(0xED, DATA_PORT);
        KB_WAIT();
        out(leds, DATA_PORT);
}
/*
void klavier_dst(int dsr_level, void *data)
{
  __dbg_printk("Klavier DSR level=%d machin=0x%x\n",
	       dsr_level, (int) data);
}
*/

/*
int register_tty_in_handler(tty_in_handler_t handler)
{
  tty_in_handler = handler;
  return 0;
}
*/

int clavier(void)
{
  int cc;
  int c = (int) in(DATA_PORT);
//  char * video = (char*) 0xb8000;
//  mark_dsr(1);

  if (c == 58) 
    { 
    leds = leds ^ CAPS; 
    set_leds();
    }
  else if (c == 69) 
    { 
      leds = leds ^ NUM; 
      set_leds(); 
    }
  else if (c == 70) 
    { 
      leds = leds ^ SCROLL; 
      set_leds();
    }

  switch (c) 
    {
    case 0x2a:
      ControlKeys |= (KBD_SHIFT | KBD_LEFTSHIFT);
      break;
      
    case 0x36:
      ControlKeys |= (KBD_SHIFT | KBD_RIGHTSHIFT);
      break;

    case 0x38:
      ControlKeys |= (KBD_ALT);
      break;

    case 0xaa:
      ControlKeys &= ~KBD_LEFTSHIFT;
      if (! (ControlKeys & KBD_RIGHTSHIFT))
	ControlKeys &= ~KBD_SHIFT;
      break;
      
    case 0xb6:
      ControlKeys &= ~KBD_RIGHTSHIFT;
      if (! (ControlKeys & KBD_LEFTSHIFT))
	ControlKeys &= ~KBD_SHIFT;
      break;

    case 0xb8:
      ControlKeys &= ~KBD_ALT;
      break;
  }

  if (c < 0x80) {
    cc = stoa(c);
    video[0]=(char) cc;
    
//    if(tty_in_handler) tty_in_handler(cc);
  }

  return 0;
}







